<?php 
/* SVN FILE: $Id$ */
/* SchedulesController Test cases generated on: 2008-12-13 14:12:24 : 1229147604*/
App::import('Controller', 'Schedules');

class TestSchedules extends SchedulesController {
	var $autoRender = false;
}

class SchedulesControllerTest extends CakeTestCase {
	var $Schedules = null;

	function startTest($method) {	// setupから変更
		$this->Schedules = new TestSchedules();
	}

	function testSchedulesControllerInstance() {
		$this->Schedules->constructClasses();
		$this->assertTrue(is_a($this->Schedules, 'SchedulesController'));
	}

	function testDefaultIndexAction() {
		$result = $this->testAction('/schedules/', array('return'=>'vars','fixturize'=>true));
		$this->assertEqual('week', $result['scope']);
		$this->assertEqual(date('Y/m/d'), $result['current']);
		$this->assertTrue(!empty($result['times']['from_time']));
		$this->assertTrue(!empty($result['times']['to_time']));
		$this->assertTrue(array_key_exists('schedules', $result));
	}
	
	function testMonthlyIndexAction() {
		$result = $this->testAction('/schedules/index/month/2008/12/', array('return'=>'vars','fixturize'=>true));
		$this->assertEqual('month', $result['scope']);
		$this->assertTrue('2008/12', substr($result['current'], 7));
		$this->assertTrue(!empty($result['times']['from_time']));
		$this->assertTrue(!empty($result['times']['to_time']));
		$this->assertTrue(array_key_exists('schedules', $result));
	}

	function testWeeklyIndexAction() {
		$result = $this->testAction('/schedules/index/week/2008/12/24', array('return'=>'vars','fixturize'=>true));
		$this->assertEqual('week', $result['scope']);
		$this->assertTrue('2008/12/24', $result['current']);
		$this->assertTrue(!empty($result['times']['from_time']));
		$this->assertTrue(!empty($result['times']['to_time']));
		$this->assertTrue(array_key_exists('schedules', $result));
	}

	function testDailyIndexAction() {
		$result = $this->testAction('/schedules/index/day/2008/12/24', array('return'=>'vars','fixturize'=>true));
		$this->assertEqual('day', $result['scope']);
		$this->assertTrue('2008/12/24', $result['current']);
		$this->assertTrue(!empty($result['times']['from_time']));
		$this->assertTrue(!empty($result['times']['to_time']));
		$this->assertTrue(array_key_exists('schedules', $result));
	}

	function endTest($method) {	// tearDownから変更
		unset($this->Schedules);
	}
}
?>